/*
 //  script.js
 //  Pulp
 //
 //  Created by Dustin MacDonald on 10-01-30.
 //  Copyright 2011 Acrylic Software. All rights reserved.
 */

var kPulpTransitionNone = 0;
var kPulpTransitionLeft = 1;
var kPulpTransitionRight = 2;
var kPulpTransitionFade = 3;

var currentOffset = 0;
var articlePosition = 0;
var transformMode = true;
var currentPage = null;
var newPage = null;
var oldPage = null;
var currentTransition = null;
var gestureCount = 0;
var swipeCompleted = true;
var gestureEnded = false;

var leftPage = null;
var rightPage = null;

function createPages(){
	if(leftPage == null){
		leftPage = createPage();
		leftPage.setAttribute("id", "left");
		$(leftPage).css("-webkit-transform", "translate(-100%, 0px)");
		document.body.appendChild(leftPage);
	}
	
	if(rightPage == null){
		rightPage = createPage();
		rightPage.setAttribute("id", "right");
		$(rightPage).css("-webkit-transform", "translate(100%, 0px)");
		document.body.appendChild(rightPage);
	}
}

function positionPages(){
	if(leftPage !== null)
		$(leftPage).css("-webkit-transform", strTranslateX(-100));
	
	if(rightPage !== null)
		$(rightPage).css("-webkit-transform", strTranslateX(100));
	
	if(currentPage !== null)
		$(currentPage).css("-webkit-transform", "translate(0px, 0px)");
}

function strTranslateX(x){
	return "translate(" + x + "%, 0px)";
}

function setArticlePosition(position){
    if(leftPage == null)
		createPages();
	
	//var offset = (currentOffset < 0) ? -currentOffset : currentOffset;
	
	articlePosition = (position * 100);
	// + currentOffset;
	
	/*if(articlePosition < -100)
		articlePosition = -100;
	else if(articlePosition > 100)
		articlePosition = 100;*/
	
	var opacity = (position < 0) ? -position : position;
	var lPage = $(leftPage);
	lPage.css("-webkit-transform", strTranslateX(articlePosition - 100));
	lPage.css("opacity", opacity);
	lPage.css("top", window.pageYOffset);
	
	var rPage = $(rightPage);
    rPage.css("-webkit-transform", strTranslateX(articlePosition + 100));
	rPage.css("opacity", opacity);
	rPage.css("top", window.pageYOffset);
	
	opacity = 1 - opacity;
	
	$(currentPage).css("opacity", opacity);
    $(currentPage).css("-webkit-transform", strTranslateX(articlePosition));
	
	/*if(position == -1){
		var leftPageRef = leftPage;
		leftPage = currentPage;
		currentPage = rightPage;
		rightPage = leftPageRef;
		$(rightPage).css("-webkit-transform", "translate(100%, 0px)");
	}else if(position == 1){
		var rightPageRef = rightPage;
		rightPage = currentPage;
		currentPage = leftPage;
		leftPage = rightPageRef;
		$(leftPage).css("-webkit-transform", "translate(-100%, 0px)");
	}*/
}

function beginGesture(){
	/*currentOffset = articlePosition;
	
	swipeCompleted = false;
	gestureEnded = false;
	
	gestureCount++;*/
}

function completeSwipe(){
	setArticlePosition(0);
	
	$(rightPage).remove();
	rightPage = null;
	
	$(leftPage).remove();
	leftPage = null;
	
	//setPageArticle(rightPage, null);
	//setPageArticle(leftPage, null);
}

function endGesture(){
	var didChange = false;
	
	if (articlePosition < 0){
		currentPage.setAttribute("id", "left");
		rightPage.setAttribute("id", "center");
		leftPage.setAttribute("id", "right");
		didChange = true;
	}else if(articlePosition > 0){
		rightPage.setAttribute("id", "left");
		leftPage.setAttribute("id", "center");
		currentPage.setAttribute("id", "right");
		didChange = true;
	}
	
	if(didChange){
		currentPage = document.getElementById("center");
		rightPage = document.getElementById("right");
		leftPage = document.getElementById("left");
		//articlePosition = 0;
		//setArticlePosition(0);
	}
}

function setArticleForPage(article, pageName){
	if(leftPage == null)
		createPages();
	
	if(pageName == "left")
		setPageArticle(leftPage, article);
	else if(pageName == "right")
		setPageArticle(rightPage, article);
}

function setArticle(article, transition) {
    removeOldPage();
    
    if(currentPage == null){
        currentPage = createPage();
		$(currentPage).attr("id", "center");
        document.body.appendChild(currentPage);
    }
    
    var pageToSet = currentPage;
    currentTransition = transition;
    
    if (transition != kPulpTransitionNone) {
        newPage = createPage();
        if (transition == kPulpTransitionFade) { // We're doing a cross-fade
			$(newPage).css({"-webkit-transition": "opacity .25s ease-in-out", "opacity": "0", "z-index": "2"});
            $(newPage).addClass("acrylic-background");
			$(currentPage).css({"-webkit-transition": "opacity .25s ease-in-out"});
        } else { // We're doing a translation animation
            var translateX = (currentTransition === kPulpTransitionLeft) ? "100%" : "-100%";
            $(newPage).css(translationStyle(translateX, false));
        }
        document.body.appendChild(newPage);
        
        $("object").remove(); // Remove flash objects - they don't transition nicely
        pageToSet = newPage;
    }
    
    setPageArticle(pageToSet, article);
    
    if (transition == kPulpTransitionFade)
        window.setTimeout(beginFadeAnimation, 0);
    else if (transition != kPulpTransitionNone)
        window.setTimeout(beginSlideAnimation, 0);
}

function beginFadeAnimation() {
    $(newPage).css({"opacity": "1"});
	$(currentPage).css({"opacity": "0"});
    
    oldPage = currentPage;
    oldPage.setAttribute("id", "");
	currentPage = newPage;
	currentPage.setAttribute("id", "center");
    
    window.setTimeout(function() {
        $(currentPage).removeClass("acrylic-background");
        removeOldPage();
    }, 250);
}

function beginSlideAnimation() {
    var translateX = (currentTransition === kPulpTransitionLeft) ? "-100%" : "100%";
    
    $(currentPage).css(translationStyle(translateX, true));
    $(newPage).css(translationStyle("0px", true));
    
    oldPage = currentPage;
    oldPage.setAttribute("id", "");
	currentPage = newPage;
	currentPage.setAttribute("id", "center");
    
    window.setTimeout(function() {
        removeOldPage();
    }, 250);
}

function translationStyle(xValue, animatedFlag) {
    var style = {};
    var transitionKey = transformMode ? "-webkit-transform" : "left";
    
    var transform = transformMode ? "translate(" + xValue + ", 0px)" : xValue;
    
    style["-webkit-transition"] = animatedFlag ? transitionKey + " .25s ease-in-out" : "none";
    style[transitionKey] = transform;
    
    return style;
}

function removeOldPage() {
    if (oldPage !== null) {
        $(oldPage).remove();
        oldPage = null;
        
        $(currentPage).css({"-webkit-transition": "none", "z-index": "1"});
    }
}

function setPageArticle(page, article) {
	var validArticle = (article !== null);
	
    var titleElement = $(page).find(".acrylic-article-title");
	titleElement.attr("href", validArticle ? article.URL : "#");
	titleElement.text(validArticle ? article.title : "");
    
	var dateString = validArticle ? article.date : "";
    var dateElement = $(page).find(".acrylic-article-date");
    if (dateElement.text() != dateString)
        dateElement.text(dateString);
    
	var sourceString = validArticle ? article.source : "";
    var sourceElement = $(page).find(".acrylic-article-source");
    if (sourceElement.text() != sourceString)
        sourceElement.text(sourceString);
    
    var bodyElement = $(page).find(".acrylic-article-body");
    bodyElement.html(validArticle ? article.body : "");
}

function createPage() {
    var pageElement = createDivWithClassName("acrylic-page");
    var articleElement = createDivWithClassName("acrylic-article");
    pageElement.appendChild(articleElement);
    
    var headerElement = createDivWithClassName("acrylic-article-header");
    articleElement.appendChild(headerElement);
    
    var titleElement = createElementWithClassName("a", "acrylic-article-title");
    headerElement.appendChild(titleElement);
    
    var infoElement = createDivWithClassName("acrylic-article-info");
    headerElement.appendChild(infoElement);
    
    var dateElement = createSpanWithClassName("acrylic-article-date");
    infoElement.appendChild(dateElement);
    
    var sourceElement = createSpanWithClassName("acrylic-article-source");
    infoElement.appendChild(sourceElement);
    
    var bodyElement = createDivWithClassName("acrylic-article-body");
    articleElement.appendChild(bodyElement);
    
    return pageElement;
}

function createDivWithClassName(className) {
    return createElementWithClassName("div", className);
}

function createSpanWithClassName(className) {
    return createElementWithClassName("span", className);
}

function createElementWithClassName(tagName, className) {
    var element = document.createElement(tagName);
    element.className = className;
    return element;
}

function setFontSizeMultiplier(multiplierString){
	var multiplier = parseFloat(multiplierString);
	document.body.style.webkitTextSizeAdjust = (multiplier * 100) + "%";	
}

function setSpinnerVisible(flag){
    if(flag == true){
        $("#load-spinner").css({"display": "block"});
		setTimeout(function(){ $("#load-spinner").css({"opacity": "1"}); }, 0);
    }else{
        $("#load-spinner").css({"opacity": "0"});
        setTimeout(function(){ $("#load-spinner").css({"display": "none"}); }, 250);
    }
}